"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var loading_1 = __importDefault(require("../loading"));

var with_default_props_1 = require("../../utils/with-default-props");

var native_props_1 = require("../../utils/native-props");

var classPrefix = "adm-button";
var defaultProps = {
  color: 'default',
  fill: 'solid',
  block: false,
  loading: false,
  type: 'button'
};

exports.Button = function (p) {
  var _classnames_1$default;

  var props = with_default_props_1.mergeProps(defaultProps, p);
  var disabled = props.disabled;
  return native_props_1.withNativeProps(props, react_1["default"].createElement("button", {
    type: props.type,
    onClick: props.onClick,
    className: classnames_1["default"](classPrefix, props.color ? classPrefix + "-" + props.color : null, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-block"] = props.block, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default[classPrefix + "-fill-outline"] = props.fill === 'outline', _classnames_1$default[classPrefix + "-fill-none"] = props.fill === 'none', _classnames_1$default[classPrefix + "-mini"] = props.size === 'mini', _classnames_1$default[classPrefix + "-small"] = props.size === 'small', _classnames_1$default[classPrefix + "-large"] = props.size === 'large', _classnames_1$default[classPrefix + "-loading"] = props.loading, _classnames_1$default)),
    disabled: disabled
  }, props.loading ? react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement("div", {
    className: classPrefix + "-loading-wrapper"
  }, react_1["default"].createElement(loading_1["default"], {
    color: 'currentColor',
    size: props.size
  }), props.loadingText)) : props.children));
};