"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Card = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var native_props_1 = require("../../utils/native-props");

var classPrefix = "adm-card";

exports.Card = function (props) {
  var renderHeader = function renderHeader() {
    if (!(props.title || props.extra)) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: classnames_1["default"](classPrefix + "-header"),
      onClick: props.onHeaderClick
    }, react_1["default"].createElement("div", {
      className: classPrefix + "-header-title"
    }, props.title), props.extra);
  };

  var renderBody = function renderBody() {
    if (!props.children) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: classPrefix + "-body",
      onClick: props.onBodyClick
    }, props.children);
  };

  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classPrefix,
    onClick: props.onClick
  }, renderHeader(), renderBody()));
};