"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Group = void 0;

var react_1 = __importDefault(require("react"));

var with_default_props_1 = require("../../utils/with-default-props");

var group_context_1 = require("./group-context");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var defaultProps = {
  disabled: false,
  defaultValue: []
};
exports.Group = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props),
      value = _use_controllable_val[0],
      setValue = _use_controllable_val[1];

  return react_1["default"].createElement(group_context_1.CheckboxGroupContext.Provider // TODO: 性能优化
  , {
    // TODO: 性能优化
    value: {
      value: value,
      disabled: props.disabled,
      check: function check(v) {
        setValue([].concat(value, [v]));
      },
      uncheck: function uncheck(v) {
        setValue(value.filter(function (item) {
          return item !== v;
        }));
      }
    }
  }, props.children);
});