"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DesenseText = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var native_props_1 = require("../../utils/native-props");

var with_default_props_1 = require("../../utils/with-default-props");

var icons_1 = __importDefault(require("@ant-design/icons"));

var icon_eye_1 = require("../icons/icon-eye");

var icon_eye_close_1 = require("../icons/icon-eye-close");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var defaultProps = {
  defaultDesense: true
};

exports.DesenseText = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  var text = props.text,
      desenseText = props.desenseText;

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue({
    value: props.desense,
    defaultValue: props.defaultDesense,
    onChange: props.onChange
  }),
      isDesense = _use_controllable_val[0],
      setIsDesense = _use_controllable_val[1];

  return native_props_1.withNativeProps(props, react_1["default"].createElement("span", {
    className: 'adm-desense-text'
  }, isDesense ? desenseText : text, react_1["default"].createElement("a", {
    className: classnames_1["default"]('adm-desense-text-icon-wrap', 'adm-plain-anchor'),
    onClick: function onClick() {
      setIsDesense(!isDesense);
    }
  }, react_1["default"].createElement(icons_1["default"], {
    component: isDesense ? icon_eye_close_1.IconEyeClose : icon_eye_1.IconEye
  }))));
};