"use strict";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dialog = void 0;

var react_1 = __importDefault(require("react"));

var with_default_props_1 = require("../../utils/with-default-props");

var classnames_1 = __importDefault(require("classnames"));

var mask_1 = __importDefault(require("../mask"));

var dialog_action_button_1 = require("./dialog-action-button");

var image_1 = __importDefault(require("../image"));

var space_1 = __importDefault(require("../space"));

var classPrefix = "adm-dialog";
var defaultProps = {
  actions: [],
  closeOnAction: false,
  closeOnMaskClick: false
};

exports.Dialog = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  return react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    destroyOnClose: true,
    getContainer: props.getContainer,
    afterClose: props.afterClose,
    onMaskClick: props.closeOnMaskClick ? props.onClose : undefined,
    style: props.maskStyle,
    className: classnames_1["default"](classPrefix + "-mask", props.maskClassName)
  }, react_1["default"].createElement("div", {
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    className: classPrefix + "-wrap"
  }, !!props.image && react_1["default"].createElement(image_1["default"], {
    src: props.image,
    alt: 'dialog header image',
    width: '100%'
  }), react_1["default"].createElement("div", {
    style: props.bodyStyle,
    className: classnames_1["default"](classPrefix + "-body", props.bodyClassName)
  }, react_1["default"].createElement(space_1["default"], {
    direction: 'vertical',
    block: true
  }, !!props.header && react_1["default"].createElement("div", {
    className: classPrefix + "-body-header-wrapper"
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-body-header"
  }, props.header)), !!props.title && react_1["default"].createElement("div", {
    className: classPrefix + "-body-title"
  }, props.title), !!props.content && react_1["default"].createElement("div", {
    className: classPrefix + "-body-message-wrapper"
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-body-message"
  }, props.content)))), react_1["default"].createElement("div", {
    className: classPrefix + "-footer"
  }, props.actions.map(function (row, index) {
    var actions = Array.isArray(row) ? row : [row];
    return react_1["default"].createElement("div", {
      className: classPrefix + "-action-row",
      key: index
    }, actions.map(function (action, index) {
      return react_1["default"].createElement(dialog_action_button_1.DialogActionButton, {
        key: action.key,
        action: action,
        onAction: function onAction() {
          return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var _a, _b;

            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (_a = props.onAction) === null || _a === void 0 ? void 0 : _a.call(props, action, index);

                  case 2:
                    if (props.closeOnAction) {
                      (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
                    }

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));
        }
      });
    }));
  }))));
};