"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GridItem = exports.Grid = void 0;

var with_default_props_1 = require("../../utils/with-default-props");

var react_1 = __importDefault(require("react"));

var native_props_1 = require("../../utils/native-props");

var classPrefix = "adm-grid";
var defaultProps = {
  gap: 0
};
exports.Grid = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var gapStyle = {};
  var gap = props.gap;

  if (gap) {
    var _ref = Array.isArray(gap) ? gap : [gap, gap],
        horizontalGap = _ref[0],
        verticalGap = _ref[1];

    gapStyle = Object.assign(Object.assign({}, gapStyle), {
      '--vertical-gap': typeof verticalGap === 'number' ? verticalGap + "px" : verticalGap,
      '--horizontal-gap': typeof horizontalGap === 'number' ? horizontalGap + "px" : horizontalGap
    });
  }

  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classPrefix,
    style: Object.assign(Object.assign({}, gapStyle), {
      '--columns': props.columns
    })
  }, props.children));
});
exports.GridItem = with_default_props_1.withDefaultProps({
  span: 1
})(function (props) {
  var itemStyle = {
    '--item-span': props.span
  };
  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classPrefix + "-item",
    style: itemStyle
  }, props.children));
});