"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageUploader = void 0;

var react_1 = __importStar(require("react"));

var icons_1 = require("@ant-design/icons");

var with_default_props_1 = require("../../utils/with-default-props");

var image_viewer_1 = __importDefault(require("../image-viewer"));

var preview_item_1 = __importDefault(require("./preview-item"));

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var ahooks_1 = require("ahooks");

var space_1 = __importDefault(require("../space"));

var convert_px_1 = require("../../utils/convert-px");

var classPrefix = "adm-image-uploader";
var defaultProps = {
  disableUpload: false,
  deletable: true,
  showUpload: true,
  multiple: false,
  maxCount: 0,
  defaultValue: [],
  capture: '',
  accept: 'image/*'
};

exports.ImageUploader = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props),
      value = _use_controllable_val[0],
      setValue = _use_controllable_val[1];

  var updateValue = ahooks_1.usePersistFn(function (updater) {
    setValue(updater(value));
  });

  var _react_1$useState = react_1.useState([]),
      tasks = _react_1$useState[0],
      setTasks = _react_1$useState[1];

  react_1.useLayoutEffect(function () {
    setTasks(function (prev) {
      return prev.filter(function (task) {
        if (task.url === undefined) return true;
        return !value.some(function (fileItem) {
          return fileItem.url === task.url;
        });
      });
    });
  }, [value]);
  var idCountRef = react_1.useRef(0);
  var maxCount = props.maxCount,
      onPreview = props.onPreview;

  function onChange(e) {
    var _a;

    return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var _this = this;

      var rawFiles, files, exceed, newTasks;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              rawFiles = e.target.files;

              if (rawFiles) {
                _context2.next = 3;
                break;
              }

              return _context2.abrupt("return");

            case 3:
              files = [].slice.call(rawFiles);

              if (!props.beforeUpload) {
                _context2.next = 8;
                break;
              }

              _context2.next = 7;
              return props.beforeUpload(files);

            case 7:
              files = _context2.sent;

            case 8:
              if (!(files.length === 0)) {
                _context2.next = 10;
                break;
              }

              return _context2.abrupt("return");

            case 10:
              exceed = value.length + files.length - maxCount;

              if (exceed > 0) {
                files = files.slice(0, maxCount - exceed);
                (_a = props.onCountExceed) === null || _a === void 0 ? void 0 : _a.call(props, exceed);
              }

              newTasks = files.map(function (file) {
                return {
                  id: idCountRef.current++,
                  status: 'pending',
                  file: file
                };
              });
              setTasks(function (prev) {
                return [].concat(prev, newTasks);
              });
              _context2.next = 16;
              return Promise.all(newTasks.map(function (currentTask) {
                return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  var result;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.prev = 0;
                          _context.next = 3;
                          return props.upload(currentTask.file);

                        case 3:
                          result = _context.sent;
                          setTasks(function (prev) {
                            return prev.map(function (task) {
                              if (task.id === currentTask.id) {
                                return Object.assign(Object.assign({}, task), {
                                  url: result.url
                                });
                              }

                              return task;
                            });
                          });
                          updateValue(function (prev) {
                            return [].concat(prev, [{
                              url: result.url
                            }]);
                          });
                          _context.next = 12;
                          break;

                        case 8:
                          _context.prev = 8;
                          _context.t0 = _context["catch"](0);
                          setTasks(function (prev) {
                            return prev.map(function (task) {
                              if (task.id === currentTask.id) {
                                return Object.assign(Object.assign({}, task), {
                                  status: 'fail'
                                });
                              }

                              return task;
                            });
                          });
                          throw _context.t0;

                        case 12:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, null, [[0, 8]]);
                }));
              }));

            case 16:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
  }

  function previewImage(index) {
    image_viewer_1["default"].Multi.show({
      images: value.map(function (fileItem) {
        return fileItem.url;
      }),
      defaultIndex: index
    });
    onPreview && onPreview(index);
  }

  var showUpload = props.showUpload && (maxCount === 0 || value.length + tasks.length < maxCount);
  return react_1["default"].createElement("div", {
    className: classPrefix
  }, react_1["default"].createElement(space_1["default"], {
    size: convert_px_1.convertPx(12),
    wrap: true
  }, value.map(function (fileItem, index) {
    return react_1["default"].createElement(preview_item_1["default"], {
      key: fileItem.url,
      url: fileItem.url,
      deletable: props.deletable,
      onClick: function onClick() {
        return previewImage(index);
      },
      onDelete: function onDelete() {
        setValue(value.filter(function (x) {
          return x.url !== fileItem.url;
        }));
      }
    });
  }), tasks.map(function (task) {
    return react_1["default"].createElement(preview_item_1["default"], {
      key: task.id,
      file: task.file,
      deletable: task.status !== 'pending',
      status: task.status,
      onDelete: function onDelete() {
        setValue(value.filter(function (x) {
          return x.url !== task.url;
        }));
      }
    });
  }), showUpload && react_1["default"].createElement("span", {
    className: classPrefix + "-cell " + classPrefix + "-upload-button",
    role: 'button'
  }, react_1["default"].createElement("span", {
    className: classPrefix + "-upload-button-icon"
  }, react_1["default"].createElement(icons_1.PlusOutlined, null)), !props.disableUpload && react_1["default"].createElement("input", {
    capture: props.capture,
    accept: props.accept,
    multiple: props.multiple,
    type: 'file',
    className: classPrefix + "-input",
    onChange: onChange
  }))));
};