"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var icons_1 = require("@ant-design/icons");

var classnames_1 = __importDefault(require("classnames"));

var image_1 = __importDefault(require("../image"));

var classPrefix = "adm-image-uploader";

var PreviewItem = function PreviewItem(props) {
  var url = props.url,
      file = props.file,
      deletable = props.deletable,
      onDelete = props.onDelete;
  var src = react_1.useMemo(function () {
    if (url) {
      return url;
    }

    if (file) {
      return URL.createObjectURL(file);
    }

    return '';
  }, [url, file]);

  function renderLoading() {
    return props.status === 'pending' && react_1["default"].createElement("div", {
      className: classPrefix + "-cell-mask"
    }, react_1["default"].createElement("span", {
      className: classPrefix + "-cell-loading"
    }, react_1["default"].createElement(icons_1.LoadingOutlined, null), react_1["default"].createElement("span", {
      className: classPrefix + "-cell-mask-message"
    }, "\u4E0A\u4F20\u4E2D...")));
  }

  function renderDelete() {
    return deletable && react_1["default"].createElement("span", {
      className: classPrefix + "-cell-delete",
      onClick: onDelete
    }, react_1["default"].createElement(icons_1.CloseOutlined, null));
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix + "-cell", props.status === 'fail' && classPrefix + "-cell-fail")
  }, react_1["default"].createElement(image_1["default"], {
    className: classPrefix + "-cell-image",
    src: src,
    onClick: props.onClick
  }), renderLoading(), renderDelete());
};

exports["default"] = PreviewItem;