import React from 'react';
import { NativeProps } from '../../utils/native-props';
export declare type InputProps = Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, 'maxLength' | 'autoComplete' | 'enterKeyHint' | 'pattern' | 'type' | 'onFocus' | 'onBlur'> & {
    value?: string;
    defaultValue?: string;
    onChange?: (val: string) => void;
    placeholder?: string;
    disabled?: boolean;
    readOnly?: boolean;
    clearable?: boolean;
    onClear?: () => void;
    id?: string;
} & NativeProps<'--font-size' | '--color' | '--placeholder-color' | '--disabled-color'>;
export declare type InputRef = {
    clear: () => void;
    focus: () => void;
    blur: () => void;
};
export declare const Input: React.ForwardRefExoticComponent<Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, "pattern" | "onFocus" | "onBlur" | "autoComplete" | "maxLength" | "type" | "enterKeyHint"> & {
    value?: string | undefined;
    defaultValue?: string | undefined;
    onChange?: ((val: string) => void) | undefined;
    placeholder?: string | undefined;
    disabled?: boolean | undefined;
    readOnly?: boolean | undefined;
    clearable?: boolean | undefined;
    onClear?: (() => void) | undefined;
    id?: string | undefined;
} & NativeProps<"--font-size" | "--color" | "--placeholder-color" | "--disabled-color"> & React.RefAttributes<InputRef>>;
