"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Mask = void 0;

var use_initialized_1 = require("../../utils/use-initialized");

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importStar(require("react"));

var react_dom_1 = require("react-dom");

var react_transition_group_1 = require("react-transition-group");

var use_lock_scroll_1 = require("../../utils/use-lock-scroll");

var classPrefix = "adm-mask";

exports.Mask = function (props) {
  var _classnames_1$default;

  var cls = classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-hidden"] = !props.visible, _classnames_1$default));
  var initialized = use_initialized_1.useInitialized(props.visible || props.forceRender);
  var ref = react_1.useRef(null);
  use_lock_scroll_1.useLockScroll(ref, !!(props.visible && props.disableBodyScroll));

  function handleClick(e) {
    var _a;

    if (e.currentTarget === e.target) {
      (_a = props.onMaskClick) === null || _a === void 0 ? void 0 : _a.call(props, e);
    }
  }

  var opacity = props.opacity === 'default' ? 0.55 : props.opacity === 'dark' ? 0.75 : props.opacity;
  var node = react_1["default"].createElement(react_transition_group_1.CSSTransition, {
    "in": props.visible,
    timeout: 200,
    classNames: classPrefix,
    onExited: props.afterClose,
    unmountOnExit: props.destroyOnClose
  }, react_1["default"].createElement("div", {
    className: cls,
    onClick: handleClick,
    ref: ref,
    style: Object.assign(Object.assign({}, props.style), {
      backgroundColor: "rgba(0, 0, 0, " + opacity + ")"
    })
  }, initialized && props.children));

  if (props.getContainer) {
    var container = typeof props.getContainer === 'function' ? props.getContainer() : props.getContainer;
    return react_dom_1.createPortal(node, container);
  }

  return node;
};

exports.Mask.defaultProps = {
  visible: true,
  destroyOnClose: false,
  forceRender: false,
  opacity: 'default',
  disableBodyScroll: true
};