import React from 'react';
import { InputRef } from '../input';
import { NativeProps } from '../../utils/native-props';
export declare type SearchRef = InputRef;
export declare type SearchProps = {
    value?: string;
    defaultValue?: string;
    maxLength?: number;
    placeholder?: string;
    clearable?: boolean;
    showCancelButton?: boolean;
    onSearch?: (val: string) => void;
    onChange?: (val: string) => void;
    onFocus?: () => void;
    onBlur?: () => void;
    onClear?: () => void;
    onCancel?: () => void;
} & NativeProps<'--background' | '--border-radius' | '--placeholder-color'>;
export declare const Search: React.ForwardRefExoticComponent<{
    value?: string | undefined;
    defaultValue?: string | undefined;
    maxLength?: number | undefined;
    placeholder?: string | undefined;
    clearable?: boolean | undefined;
    showCancelButton?: boolean | undefined;
    onSearch?: ((val: string) => void) | undefined;
    onChange?: ((val: string) => void) | undefined;
    onFocus?: (() => void) | undefined;
    onBlur?: (() => void) | undefined;
    onClear?: (() => void) | undefined;
    onCancel?: (() => void) | undefined;
} & NativeProps<"--placeholder-color" | "--background" | "--border-radius"> & React.RefAttributes<InputRef>>;
