"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Search = void 0;

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var input_1 = __importDefault(require("../input"));

var native_props_1 = require("../../utils/native-props");

var with_default_props_1 = require("../../utils/with-default-props");

var icons_1 = require("@ant-design/icons");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var classPrefix = "adm-search";
var defaultProps = {
  clearable: true,
  showCancelButton: false,
  defaultValue: ''
};
exports.Search = react_1.forwardRef(function (p, ref) {
  var _classnames_1$default;

  var props = with_default_props_1.mergeProps(defaultProps, p);

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props),
      value = _use_controllable_val[0],
      setValue = _use_controllable_val[1];

  var _react_1$useState = react_1.useState(false),
      hasFocus = _react_1$useState[0],
      setHasFocus = _react_1$useState[1];

  var inputRef = react_1.useRef(null);
  react_1.useImperativeHandle(ref, function () {
    return {
      clear: function clear() {
        var _a;

        return (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.clear();
      },
      focus: function focus() {
        var _a;

        return (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
      },
      blur: function blur() {
        var _a;

        return (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.blur();
      }
    };
  });
  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-active"] = hasFocus, _classnames_1$default))
  }, react_1["default"].createElement("form", {
    className: classPrefix + "-input-box",
    action: '/',
    onSubmit: function onSubmit(e) {
      var _a, _b;

      e.preventDefault();
      e.stopPropagation();
      (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.blur();
      (_b = props.onSearch) === null || _b === void 0 ? void 0 : _b.call(props, value);
    }
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-input-box-icon"
  }, react_1["default"].createElement(icons_1.SearchOutlined, null)), react_1["default"].createElement(input_1["default"], {
    ref: inputRef,
    className: classPrefix + "-input",
    value: value,
    onChange: setValue,
    maxLength: props.maxLength,
    placeholder: props.placeholder,
    clearable: props.clearable,
    onFocus: function onFocus() {
      var _a;

      setHasFocus(true);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    onBlur: function onBlur() {
      var _a;

      setHasFocus(false);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    onClear: props.onClear,
    type: 'search'
  })), props.showCancelButton && hasFocus && react_1["default"].createElement("div", {
    className: classPrefix + "-suffix"
  }, react_1["default"].createElement("a", {
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onTouchStart: function onTouchStart(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      var _a, _b, _c;

      (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.clear();
      (_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.blur();
      (_c = props.onCancel) === null || _c === void 0 ? void 0 : _c.call(props);
    }
  }, "\u53D6\u6D88"))));
});