"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Selector = void 0;

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var native_props_1 = require("../../utils/native-props");

var with_default_props_1 = require("../../utils/with-default-props");

var space_1 = __importDefault(require("../space"));

var grid_1 = __importDefault(require("../grid"));

var convert_px_1 = require("../../utils/convert-px");

var selector_check_mark_svg_1 = __importDefault(require("../../assets/selector-check-mark.svg"));

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var classPrefix = "adm-selector";
var defaultProps = {
  multiple: false,
  defaultValue: []
};

exports.Selector = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props),
      value = _use_controllable_val[0],
      setValue = _use_controllable_val[1];

  var items = props.options.map(function (option) {
    var _classnames_1$default;

    var active = (value || []).includes(option.value);
    var disabled = option.disabled || props.disabled;
    var itemCls = classnames_1["default"](classPrefix + "-item", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-item-active"] = active && !props.multiple, _classnames_1$default[classPrefix + "-item-multiple-active"] = active && props.multiple, _classnames_1$default[classPrefix + "-item-disabled"] = disabled, _classnames_1$default));
    return react_1["default"].createElement("div", {
      key: option.value,
      className: itemCls,
      onClick: function onClick() {
        if (disabled) {
          return;
        }

        if (props.multiple) {
          setValue(active ? value.filter(function (v) {
            return v !== option.value;
          }) : [].concat(value, [option.value]));
        } else {
          setValue(active ? [] : [option.value]);
        }
      }
    }, option.label, active && props.multiple && react_1["default"].createElement("div", {
      className: classPrefix + "-check-mark-wrapper"
    }, react_1["default"].createElement("img", {
      src: selector_check_mark_svg_1["default"]
    })));
  });
  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classPrefix
  }, !props.columns && react_1["default"].createElement(space_1["default"], {
    wrap: true
  }, items), props.columns && react_1["default"].createElement(grid_1["default"], {
    columns: props.columns,
    gap: convert_px_1.convertPx(8)
  }, items)));
};