"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Space = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var native_props_1 = require("../../utils/native-props");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "adm-space";
exports.Space = with_default_props_1.withDefaultProps({
  direction: 'horizontal'
})(function (props) {
  var _classnames_1$default;

  var size = props.size,
      direction = props.direction;
  var sizeStyle = {};

  if (size) {
    var _ref = Array.isArray(size) ? size : [size, size],
        horizontalSize = _ref[0],
        verticalSize = _ref[1];

    sizeStyle = {
      '--vertical-size': typeof verticalSize === 'number' ? verticalSize + "px" : verticalSize,
      '--horizontal-size': typeof horizontalSize === 'number' ? horizontalSize + "px" : horizontalSize
    };
  }

  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-wrap"] = props.wrap, _classnames_1$default[classPrefix + "-block"] = props.block, _classnames_1$default[classPrefix + "-" + direction] = true, _classnames_1$default[classPrefix + "-align-" + props.align] = !!props.align, _classnames_1$default)),
    style: sizeStyle
  }, react_1["default"].Children.map(props.children, function (child) {
    return child !== null && child !== undefined && react_1["default"].createElement("div", {
      className: classPrefix + "-item"
    }, child);
  })));
});