"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabBar = exports.TabBarItem = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var native_props_1 = require("../../utils/native-props");

var badge_1 = __importDefault(require("../badge"));

var use_controllable_value_1 = require("../../utils/use-controllable-value");

exports.TabBarItem = function () {
  return null;
};

exports.TabBar = function (props) {
  var _a;

  var firstActiveKey = null;
  var items = [];
  react_1["default"].Children.forEach(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue({
    value: props.activeKey,
    defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : firstActiveKey,
    onChange: props.onChange
  }),
      activeKey = _use_controllable_val[0],
      setActiveKey = _use_controllable_val[1];

  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: 'adm-tab-bar'
  }, items.map(function (item) {
    function renderContent() {
      var iconElement = item.props.icon && react_1["default"].createElement("div", {
        className: 'adm-tab-bar-item-icon'
      }, item.props.icon);
      var titleElement = item.props.title && react_1["default"].createElement("div", {
        className: 'adm-tab-bar-item-title'
      }, item.props.title);

      if (item.props.badge !== undefined) {
        if (iconElement) {
          return react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement(badge_1["default"], {
            content: item.props.badge,
            offset: [0, 6]
          }, iconElement), titleElement);
        } else if (titleElement) {
          return react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement(badge_1["default"], {
            content: item.props.badge,
            offset: [2, -2]
          }, titleElement));
        }
      } else {
        return react_1["default"].createElement(react_1["default"].Fragment, null, iconElement, titleElement);
      }

      return null;
    }

    return native_props_1.withNativeProps(item.props, react_1["default"].createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      },
      className: classnames_1["default"]('adm-tab-bar-item', {
        'adm-tab-bar-item-active': item.key === activeKey
      })
    }, renderContent()));
  })));
};