"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = exports.TabPane = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var native_props_1 = require("../../utils/native-props");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var classPrefix = "adm-tabs";

exports.TabPane = function () {
  return null;
};

exports.Tabs = function (props) {
  var _a;

  var childrenRecord = {};
  var firstActiveKey = null;
  var panes = [];
  react_1["default"].Children.forEach(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    childrenRecord[key] = child.props.children;
    panes.push(child);
  });

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue({
    value: props.activeKey,
    defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : firstActiveKey,
    onChange: props.onChange
  }),
      activeKey = _use_controllable_val[0],
      setActiveKey = _use_controllable_val[1];

  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: classPrefix
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-tab-list"
  }, panes.map(function (pane) {
    var _classnames_1$default;

    return native_props_1.withNativeProps(pane.props, react_1["default"].createElement("div", {
      key: pane.key,
      className: classPrefix + "-tab-wrapper"
    }, react_1["default"].createElement("div", {
      onClick: function onClick() {
        var key = pane.key;

        if (key === undefined || key === null) {
          return;
        }

        setActiveKey(key.toString());
      },
      className: classnames_1["default"](classPrefix + "-tab", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-tab-active"] = pane.key === activeKey, _classnames_1$default))
    }, pane.props.title)));
  })), panes.map(function (pane) {
    if (pane.props.children === undefined) {
      return null;
    }

    if (pane.key === activeKey) {
      return react_1["default"].createElement("div", {
        key: pane.key,
        className: classPrefix + "-content"
      }, pane.props.children);
    }

    if (pane.props.forceRender) {
      return react_1["default"].createElement("div", {
        key: pane.key,
        style: {
          display: 'none'
        }
      }, pane.props.children);
    }

    return null;
  })));
};