"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clear = exports.show = void 0;

var react_1 = __importStar(require("react"));

var noop_1 = require("../../utils/noop");

var get_container_1 = require("../../utils/get-container");

var react_dom_1 = __importDefault(require("react-dom"));

var ahooks_1 = require("ahooks");

var toast_1 = require("./toast");

var toastArray = [];

function show(p) {
  var props = typeof p === 'string' ? {
    content: p
  } : p;
  var timer = 0;
  var _props$afterClose = props.afterClose,
      afterClose = _props$afterClose === void 0 ? noop_1.noop : _props$afterClose,
      _props$getContainer = props.getContainer,
      getContainer = _props$getContainer === void 0 ? function () {
    return document.body;
  } : _props$getContainer;
  var container = document.createElement('div');
  var bodyContainer = get_container_1.resolveContainer(getContainer);
  bodyContainer.appendChild(container);

  var TempToast = function TempToast() {
    var _react_1$useState = react_1.useState(true),
        visible = _react_1$useState[0],
        setVisible = _react_1$useState[1];

    var _react_1$useState2 = react_1.useState(Object.assign({
      duration: 2000
    }, props)),
        state = _react_1$useState2[0],
        setState = _react_1$useState2[1]; // clearDOM after animation


    var _afterClose = function _afterClose() {
      afterClose();
      var unmountResult = react_dom_1["default"].unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    }; // close with animation


    var destroy = react_1.useCallback(function () {
      setVisible(false);
    }, []);
    react_1.useEffect(function () {
      _clear();

      toastArray.push(_afterClose);
    }, []);
    react_1.useEffect(function () {
      if (state.duration !== 0 && 'duration' in state) {
        timer = window.setTimeout(destroy, state.duration);
      }

      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []); // 当修改 duration 时，重新计时

    ahooks_1.useUpdateEffect(function () {
      if ('duration' in state) {
        window.clearTimeout(timer);
        timer = window.setTimeout(destroy, state.duration);
      }
    }, [state.duration]);
    return react_1["default"].createElement(toast_1.InternalToast, Object.assign({}, state, {
      getContainer: function getContainer() {
        return container;
      },
      visible: visible,
      afterClose: _afterClose
    }));
  };

  react_dom_1["default"].render(react_1["default"].createElement(TempToast, null), container);
}

exports.show = show; // 同步的销毁

function _clear() {
  var fn = toastArray.pop();

  while (fn) {
    fn();
    fn = toastArray.pop();
  }
} // 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。


function clear() {
  setTimeout(_clear);
}

exports.clear = clear;