"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InternalToast = void 0;

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var loading_1 = __importDefault(require("../loading"));

var mask_1 = __importDefault(require("../mask"));

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "adm-toast";
var defaultProps = {
  maskClickable: true
};

exports.InternalToast = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  var maskClickable = props.maskClickable,
      content = props.content,
      icon = props.icon,
      position = props.position;
  var iconElement = react_1.useMemo(function () {
    if (icon === null || icon === undefined) return null;

    switch (icon) {
      case 'success':
        return react_1["default"].createElement(icons_1.CheckOutlined, null);

      case 'fail':
        return react_1["default"].createElement(icons_1.CloseOutlined, null);

      case 'loading':
        return react_1["default"].createElement(loading_1["default"], {
          color: 'white'
        });

      default:
        return icon;
    }
  }, [icon]);
  var top = react_1.useMemo(function () {
    switch (position) {
      case 'top':
        return '20%';

      case 'bottom':
        return '80%';

      default:
        return '50%';
    }
  }, [position]);
  return react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    destroyOnClose: true,
    opacity: 0,
    disableBodyScroll: !maskClickable,
    getContainer: props.getContainer,
    afterClose: props.afterClose,
    style: Object.assign({
      pointerEvents: maskClickable ? 'none' : 'all'
    }, props.maskStyle),
    className: classnames_1["default"](classPrefix + "-mask", props.maskClassName)
  }, react_1["default"].createElement("div", {
    style: {
      top: top
    },
    className: classnames_1["default"](classPrefix + "-wrap", icon ? classPrefix + "-wrap-icon" : classPrefix + "-wrap-text")
  }, iconElement && react_1["default"].createElement("div", {
    className: classPrefix + "-icon"
  }, iconElement), content));
};