import React, { memo } from 'react';
import classNames from 'classnames';
import { mergeProps } from '../../utils/with-default-props';
var classPrefix = "adm-loading";
var colorRecord = {
  "default": 'var(--adm-color-weak)',
  primary: 'var(--adm-color-primary)',
  white: 'var(--adm-color-white)'
};
var defaultProps = {
  size: 'middle',
  color: 'default'
};
export var Loading = /*#__PURE__*/memo(function (p) {
  var _a;

  var props = mergeProps(defaultProps, p);
  var style = {
    '--color': (_a = colorRecord[props.color]) !== null && _a !== void 0 ? _a : props.color
  };
  return /*#__PURE__*/React.createElement("div", {
    style: style,
    className: classNames(classPrefix, classPrefix + "-" + props.size)
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }));
});