import React, { ReactElement } from 'react';
import type { TooltipProps } from 'rc-tooltip/lib/Tooltip';
export declare type BasePopoverProps = {
    getContainer?: () => HTMLElement;
    destroyOnHide?: boolean;
    children: ReactElement;
    mode?: 'light' | 'dark';
    trigger?: string;
} & Pick<TooltipProps, 'defaultVisible' | 'visible' | 'placement' | 'onVisibleChange' | 'overlayStyle' | 'overlayClassName' | 'align' | 'zIndex'>;
export declare type PopoverRef = {
    show: () => void;
    hide: () => void;
    visible: boolean;
};
export declare const Popover: React.ForwardRefExoticComponent<{
    getContainer?: (() => HTMLElement) | undefined;
    destroyOnHide?: boolean | undefined;
    children: ReactElement;
    mode?: "dark" | "light" | undefined;
    trigger?: string | undefined;
} & Pick<TooltipProps, "visible" | "zIndex" | "align" | "defaultVisible" | "placement" | "onVisibleChange" | "overlayStyle" | "overlayClassName"> & {
    content: React.ReactNode;
} & React.RefAttributes<PopoverRef>>;
