import React from 'react';
import classNames from 'classnames';
import { withNativeProps } from '../../utils/native-props';
import Badge from '../badge';
import { useNewControllableValue } from '../../utils/use-controllable-value';
export var TabBarItem = function TabBarItem() {
  return null;
};
export var TabBar = function TabBar(props) {
  var _a;

  var firstActiveKey = null;
  var items = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _useNewControllableVa = useNewControllableValue({
    value: props.activeKey,
    defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : firstActiveKey,
    onChange: props.onChange
  }),
      activeKey = _useNewControllableVa[0],
      setActiveKey = _useNewControllableVa[1];

  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: 'adm-tab-bar'
  }, items.map(function (item) {
    function renderContent() {
      var iconElement = item.props.icon && /*#__PURE__*/React.createElement("div", {
        className: 'adm-tab-bar-item-icon'
      }, item.props.icon);
      var titleElement = item.props.title && /*#__PURE__*/React.createElement("div", {
        className: 'adm-tab-bar-item-title'
      }, item.props.title);

      if (item.props.badge !== undefined) {
        if (iconElement) {
          return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Badge, {
            content: item.props.badge,
            offset: [0, 6]
          }, iconElement), titleElement);
        } else if (titleElement) {
          return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Badge, {
            content: item.props.badge,
            offset: [2, -2]
          }, titleElement));
        }
      } else {
        return /*#__PURE__*/React.createElement(React.Fragment, null, iconElement, titleElement);
      }

      return null;
    }

    return withNativeProps(item.props, /*#__PURE__*/React.createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      },
      className: classNames('adm-tab-bar-item', {
        'adm-tab-bar-item-active': item.key === activeKey
      })
    }, renderContent()));
  })));
};