"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Collapse = exports.CollapsePanel = void 0;

var react_1 = __importStar(require("react"));

var native_props_1 = require("../../utils/native-props");

var list_1 = __importDefault(require("../list"));

var icons_1 = require("@ant-design/icons");

var classnames_1 = __importDefault(require("classnames"));

var use_initialized_1 = require("../../utils/use-initialized");

var web_1 = require("@react-spring/web");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

exports.CollapsePanel = function () {
  return null;
};

var CollapsePanelContent = function CollapsePanelContent(props) {
  var visible = props.visible;
  var innerRef = react_1.useRef(null);
  var initialized = use_initialized_1.useInitialized(visible || props.forceRender);

  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      from: {
        height: visible ? 'auto' : 0
      }
    };
  }),
      style = _web_1$useSpring[0],
      api = _web_1$useSpring[1];

  react_1.useEffect(function () {
    if (visible) {
      var inner = innerRef.current;
      if (!inner) return;
      api.start({
        height: inner.offsetHeight
      });
    } else {
      api.start({
        height: 0
      });
    }
  }, [visible]);
  return initialized ? react_1["default"].createElement(web_1.animated.div, {
    className: 'adm-collapse-panel-content',
    style: style
  }, react_1["default"].createElement("div", {
    className: 'adm-collapse-panel-content-inner',
    ref: innerRef
  }, react_1["default"].createElement(list_1["default"].Item, null, props.children))) : null;
};

exports.Collapse = function (props) {
  var _a;

  var panels = [];
  react_1["default"].Children.forEach(props.children, function (child) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;
    panels.push(child);
  });

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props.accordion ? {
    value: props.activeKey === undefined ? undefined : props.activeKey === null ? [] : [props.activeKey],
    defaultValue: props.defaultActiveKey === undefined || props.defaultActiveKey === null ? [] : [props.defaultActiveKey],
    onChange: function onChange(v) {
      var _a, _b;

      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, (_b = v[0]) !== null && _b !== void 0 ? _b : null);
    }
  } : {
    value: props.activeKey,
    defaultValue: (_a = props.defaultActiveKey) !== null && _a !== void 0 ? _a : [],
    onChange: props.onChange
  }),
      activeKey = _use_controllable_val[0],
      setActiveKey = _use_controllable_val[1];

  var activeKeyList = activeKey === null ? [] : Array.isArray(activeKey) ? activeKey : [activeKey];
  return native_props_1.withNativeProps(props, react_1["default"].createElement("div", {
    className: 'adm-collapse'
  }, react_1["default"].createElement(list_1["default"], null, panels.map(function (panel) {
    var key = panel.key;
    var active = activeKeyList.includes(key);

    function handleClick() {
      if (props.accordion) {
        if (active) {
          setActiveKey([]);
        } else {
          setActiveKey([key]);
        }
      } else {
        if (active) {
          setActiveKey(activeKeyList.filter(function (v) {
            return v !== key;
          }));
        } else {
          setActiveKey([].concat(activeKeyList, [key]));
        }
      }
    }

    return react_1["default"].createElement(react_1["default"].Fragment, {
      key: key
    }, react_1["default"].createElement(list_1["default"].Item, {
      className: classnames_1["default"]('adm-collapse-panel-header', {
        'adm-collapse-panel-header-disabled': panel.props.disabled
      }),
      onClick: panel.props.disabled ? undefined : handleClick,
      arrow: react_1["default"].createElement("div", {
        className: classnames_1["default"]('adm-collapse-arrow', {
          'adm-collapse-arrow-active': active
        })
      }, react_1["default"].createElement(icons_1.RightOutlined, null))
    }, panel.props.title), react_1["default"].createElement(CollapsePanelContent, {
      visible: active,
      forceRender: !!panel.props.forceRender
    }, panel.props.children));
  }))));
};