"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.alert = void 0;

var show_1 = require("./show");

var with_default_props_1 = require("../../utils/with-default-props");

var defaultProps = {
  confirmText: '我知道了'
};

function alert(p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  return new Promise(function (resolve) {
    show_1.show(Object.assign(Object.assign({}, props), {
      closeOnAction: true,
      actions: [{
        key: 'confirm',
        text: props.confirmText
      }],
      onAction: props.onConfirm,
      onClose: function onClose() {
        resolve();
      }
    }));
  });
}

exports.alert = alert;