"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopMenu = void 0;

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var button_1 = __importDefault(require("../button"));

var popover_1 = require("./popover");

var classPrefix = "adm-popover";
exports.PopMenu = react_1.forwardRef(function (props, ref) {
  var innerRef = react_1.useRef(null);
  react_1.useImperativeHandle(ref, function () {
    return innerRef.current;
  }, []);

  var _onClick = react_1.useCallback(function (e) {
    var _a;

    var onSelect = props.onSelect;

    if (onSelect) {
      onSelect(e);
    }

    (_a = innerRef.current) === null || _a === void 0 ? void 0 : _a.hide();
  }, [props.onSelect]);

  var overlay = react_1.useMemo(function () {
    return react_1["default"].createElement(react_1["default"].Fragment, null, (props.actions || []).map(function (ele, index) {
      var _classnames_1$default;

      var _a;

      return react_1["default"].createElement("div", {
        className: classnames_1["default"](classPrefix + "-inner-menu", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-inner-menu-with-icon"] = !!ele.icon, _classnames_1$default)),
        key: (_a = ele.key) !== null && _a !== void 0 ? _a : index
      }, react_1["default"].createElement(button_1["default"], {
        disabled: ele.disabled,
        onClick: function onClick() {
          if (!ele.disabled) {
            _onClick(ele);
          }
        },
        fill: 'none',
        block: true
      }, ele.icon && react_1["default"].createElement("span", {
        className: classPrefix + "-inner-menu-icon"
      }, ele.icon), ele.text));
    }));
  }, [props.actions, _onClick]);
  return react_1["default"].createElement(popover_1.Popover, Object.assign({
    ref: innerRef
  }, props, {
    overlayClassName: classnames_1["default"](classPrefix + "-menu", props.overlayClassName),
    content: overlay
  }), props.children);
});