"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Radio = void 0;

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var group_context_1 = require("./group-context");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "adm-radio";
var defaultProps = {
  defaultChecked: false
};

exports.Radio = function (p) {
  var _classnames_1$default;

  var props = with_default_props_1.mergeProps(defaultProps, p);
  var groupContext = react_1.useContext(group_context_1.RadioGroupContext);

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue({
    value: props.checked,
    defaultValue: props.defaultChecked,
    onChange: props.onChange
  }),
      checked = _use_controllable_val[0],
      setChecked = _use_controllable_val[1];

  var disabled = props.disabled;
  var value = props.value;

  if (groupContext && value !== undefined) {
    checked = groupContext.value.includes(value);

    setChecked = function setChecked(checked) {
      var _a;

      if (checked) {
        groupContext.check(value);
      } else {
        groupContext.uncheck(value);
      }

      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, checked);
    };

    disabled = disabled || groupContext.disabled;
  }

  return react_1["default"].createElement("label", {
    className: classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-checked"] = checked, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default[classPrefix + "-block"] = props.block, _classnames_1$default)),
    style: props.style
  }, react_1["default"].createElement("input", {
    type: 'radio',
    checked: checked,
    onChange: function onChange(e) {
      setChecked(e.target.checked);
    },
    onClick: function onClick(e) {
      e.stopPropagation();
      e.nativeEvent.stopImmediatePropagation();
    },
    disabled: disabled,
    id: props.id
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-icon"
  }, react_1["default"].createElement(icons_1.CheckOutlined, {
    className: classPrefix + "-icon-checked"
  })), props.children && react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
};