"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Switch = void 0;

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var spin_svg_1 = __importDefault(require("../../assets/spin.svg"));

var native_props_1 = require("../../utils/native-props");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "adm-switch";
var defaultProps = {
  defaultChecked: false
};

exports.Switch = function (p) {
  var _classnames_1$default;

  var props = with_default_props_1.mergeProps(defaultProps, p);
  var disabled = props.disabled || props.loading || false;

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue({
    value: props.checked,
    defaultValue: props.defaultChecked,
    onChange: props.onChange
  }),
      checked = _use_controllable_val[0],
      setChecked = _use_controllable_val[1];

  return native_props_1.withNativeProps(props, react_1["default"].createElement("label", {
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-checked"] = checked, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default))
  }, react_1["default"].createElement("input", {
    type: 'checkbox',
    checked: checked,
    onChange: function onChange(e) {
      disabled || setChecked(e.target.checked);
    },
    disabled: disabled
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-checkbox"
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-handle"
  }, // 禁用状态优先于加载状态
  props.disabled || props.loading && react_1["default"].createElement("img", {
    src: spin_svg_1["default"],
    className: classPrefix + "-icon"
  })))));
};