"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tag = void 0;

var react_1 = __importDefault(require("react"));

var with_default_props_1 = require("../../utils/with-default-props");

var native_props_1 = require("../../utils/native-props");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "adm-tag";
var colorRecord = {
  "default": '#666666',
  primary: '#1677FF'
};
var defaultProps = {
  color: 'default',
  fill: 'solid',
  round: false
};

exports.Tag = function (p) {
  var _classnames_1$default;

  var _a;

  var props = with_default_props_1.mergeProps(defaultProps, p);
  var color = (_a = colorRecord[props.color]) !== null && _a !== void 0 ? _a : props.color;
  var style = {
    '--color': color
  };
  return native_props_1.withNativeProps(props, react_1["default"].createElement("span", {
    style: style,
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-round"] = props.round, _classnames_1$default[classPrefix + "-outline"] = props.fill === 'outline', _classnames_1$default))
  }, props.children));
};