"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRefState = void 0;

var react_1 = require("react");

function useRefState(initialState) {
  var _react_1$useState = react_1.useState(initialState),
      state = _react_1$useState[0],
      setState = _react_1$useState[1];

  var ref = react_1.useRef(state);
  react_1.useLayoutEffect(function () {
    ref.current = state;
  }, [state]);
  return [state, setState, ref];
}

exports.useRefState = useRefState;