import React, { useCallback, useEffect, useState } from 'react';
import { noop } from '../../utils/noop';
import { resolveContainer } from '../../utils/get-container';
import ReactDOM from 'react-dom';
import { useUpdateEffect } from 'ahooks';
import { InternalToast } from './toast';
var toastArray = [];
export function show(p) {
  var props = typeof p === 'string' ? {
    content: p
  } : p;
  var timer = 0;
  var _props$afterClose = props.afterClose,
      afterClose = _props$afterClose === void 0 ? noop : _props$afterClose,
      _props$getContainer = props.getContainer,
      getContainer = _props$getContainer === void 0 ? function () {
    return document.body;
  } : _props$getContainer;
  var container = document.createElement('div');
  var bodyContainer = resolveContainer(getContainer);
  bodyContainer.appendChild(container);

  var TempToast = function TempToast() {
    var _useState = useState(true),
        visible = _useState[0],
        setVisible = _useState[1];

    var _useState2 = useState(Object.assign({
      duration: 2000
    }, props)),
        state = _useState2[0],
        setState = _useState2[1]; // clearDOM after animation


    var _afterClose = function _afterClose() {
      afterClose();
      var unmountResult = ReactDOM.unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    }; // close with animation


    var destroy = useCallback(function () {
      setVisible(false);
    }, []);
    useEffect(function () {
      _clear();

      toastArray.push(_afterClose);
    }, []);
    useEffect(function () {
      if (state.duration !== 0 && 'duration' in state) {
        timer = window.setTimeout(destroy, state.duration);
      }

      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []); // 当修改 duration 时，重新计时

    useUpdateEffect(function () {
      if ('duration' in state) {
        window.clearTimeout(timer);
        timer = window.setTimeout(destroy, state.duration);
      }
    }, [state.duration]);
    return /*#__PURE__*/React.createElement(InternalToast, Object.assign({}, state, {
      getContainer: function getContainer() {
        return container;
      },
      visible: visible,
      afterClose: _afterClose
    }));
  };

  ReactDOM.render( /*#__PURE__*/React.createElement(TempToast, null), container);
} // 同步的销毁

function _clear() {
  var fn = toastArray.pop();

  while (fn) {
    fn();
    fn = toastArray.pop();
  }
} // 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。


export function clear() {
  setTimeout(_clear);
}